How to generate wasora's documentation
======================================

The documentation of wasora is contained in a set of files that
act as a source for many different output formats (html, pdf,
sphinx, plain text, etc) using the meta-markup tool doconce.
Besides, the keywords, special variables, built-in functions, etc.
are described in the very source code where they are implemented
so the distance between the code that performs an integration and
the description of what the parameters should be are located
within two lines of distance in the same file.

Setup doconce and pygments
--------------------------

Install the python-pygments package of your distribution (this
step should install all the needed dependencies):

    $ apt-get install python-pygments

Tell pygments a new source type called "wasora" exists:

    $ ./generate-lexer.sh > lexer/wasoralexer/lexer.py 
    $ cd lexer
    $ sudo python setup.py install
    $ cd ..


Download and unpack the latest doconce distribution:

    $ wget https://github.com/hplgit/doconce/tarball/master
    $ tar xvzf master

If you prefer, you may clone the git repository:

    $ git clone https://github.com/hplgit/doconce.git

Install doconce
    
    $ sudo python setup.py install
    $ cd ..


Run the make script
-------------------

Once all the needed tools are installed on your system, each time
you want to update the wasora documentation from the code sources

    $ ./make.sh

Generate the reference 
----------------------

    $ ./reference.sh

Generate the wasora logo
------------------------

    $ inkscape --export-area-drawing --export-pdf=logo.pdf logo.svg

Compile the documentation
-------------------------

    $ doconce format html wasora --html_style=bootswatch_readable --html_toc_depth=1
    $ cp wasora.html wasora_full.html
    $ doconce split_html wasora --pagination

    $ doconce format pdflatex wasora
    $ ptex2tex -DMINTED wasora
    $ pdflatex -shell-escape wasora

