#!/bin/sh
# 
#  first tell pygmentize it has a new lexer
# $ ./generate-lexer.sh > lexer/wasoralexer/lexer.py 
# $ cd lexer
# $ su
# # python setup.py install
#
# and then tell doconce that wasora can be used
# edit doconce/lib/doconce/sphinx.py
# add 'wasora' after 'yaml'
# 

. ./keywords.sh 


echo "import re"
echo 
echo "from pygments.lexer import RegexLexer, include, bygroups, using, \\"
echo "     this, combined, ExtendedRegexLexer"
echo "from pygments.token import Error, Punctuation, Literal, Token, \\"
echo "     Text, Comment, Operator, Keyword, Name, String, Number, Generic"
echo 
echo "__all__ = ['WasoraLexer']"
echo 
echo "class WasoraLexer(RegexLexer):"
echo "    \"\"\""
echo "    Lexer for wasora input files."
echo 
echo "    *Not in pygments official distribution"
echo "    \"\"\""
echo "    name = 'wasora'"
echo "    aliases = ['wasora']"
echo "    filenames = ['*.was']"
echo "    mimetypes = ['text/plain']"
echo
echo "    tokens = {"
echo "        'root': ["
echo "            # Keywords"
echo -n "             (r'\b("
echo -n $UPPER | sed s/\ /\|/g
echo ")\s*\b',"
echo "             Keyword),"
echo             
echo "            # Reserved variables"
echo -n "             (r'\b("
echo -n $VARS | sed s/\ /\|/g
echo ")\s*\b',"
echo "             Name.Builtin),"
echo
echo "            # Built-in functions, functionals and vectorfunctions"
echo -n "             (r'\b("
echo -n $FUNCS | sed s/\ /\|/g
echo ")\s*\b',"
echo "             Name.Function),"
echo
echo "            # Numbers"
echo "            (r'([0-9]*\.[0-9]*|[0-9]+)(e[+-]?[0-9]+)?', Number),"
echo "            (r' .[0-9]+', Number),"
echo            
echo "            # Operators"
echo "            (r'[&\|=!<>\+-\/\*\^]', Operator),"
echo
echo "            # Punctuation"
echo "            (r'[\(\)\[\]\{\}$,:;%\\\\\"\']', Punctuation),"
echo
echo "            # Comment (but not if escaped)"
echo "            (r'^#.*?\n', Comment),"
echo "            (r'\\#', Text),"
echo "            (r'\\\\#', Text),"
echo "            (r'\\\\\\#', Text),"
echo "            (r'.#.*?\n', Comment),"
echo
echo "            (r'[a-z][a-z0-9_]*', Text),"
echo "            (r'[A-Z][A-Z0-9_]*', Text),"
echo "            (r' ', Text),"
echo "            (r' .*', Text),"
echo
echo "        ],"
echo
echo "    }"
echo