ext="do.txt"

N=4
src=("parser" \
     "init" \
     "builtinfunctions"\
     "builtinfunctionals" \
     "builtinvectorfunctions"\
)

tag=("kw" "va" "fn" "fu" "fv")


for i in `seq 0 $N`; do

  echo ${src[$i]}
  rm -f ${src[$i]}.$ext

  kws=`cat ../src/${src[$i]}.c | grep "//${tag[$i]}+" | awk '{print $1}' | awk -F+ '{print $2}' | awk '$1 in p{next}{p[$1];print}' | sort` 

  for kw in $kws; do

    echo "  $kw"
    escapedkw=`echo $kw | sed s/_/\\\\\\\\_/g`

# title
    echo "label{$kw}" >> ${src[$i]}.$ext
    echo "idx{$kw}" >> ${src[$i]}.$ext
    echo "=== \`$kw\` ===" >> ${src[$i]}.$ext

    echo >> ${src[$i]}.$ext
    grep //${tag[$i]}+$kw+desc ../src/${src[$i]}.c | cut -d\  -f2- >> ${src[$i]}.$ext
    echo  >> ${src[$i]}.$ext 

# usage
    usage=`grep //${tag[$i]}+$kw+usage ../src/${src[$i]}.c | cut -d\  -f2- | xargs`
    if [ -n "$usage" ]; then
      cat << EOF >> ${src[$i]}.$ext
!bnotice Usage
!bc wasora
EOF
      echo $usage | sed s/\ \&nbsp\;\ /\\n/g >> ${src[$i]}.$ext
      cat << EOF >> ${src[$i]}.$ext
!ec
!enotice

EOF
    fi

# math+figure
    math=`cat ../src/${src[$i]}.c | grep //${tag[$i]}+$kw+math  | cut -d\  -f2-` >> ${src[$i]}.$ext
    if [ -n "$math" ]; then

      cat << EOF >> ${src[$i]}.$ext
# begin-grid-area
!bslidecell 00
!bt
\begin{equation*}
$math
\end{equation*}
!et
!eslidecell

EOF

      range=`cat ../src/${src[$i]}.c | grep //${tag[$i]}+$kw+plotx  | cut -d\  -f2-`
      if [ -n "$range" ]; then
       if [[ !( -e figures/$kw.png ) ]]; then
        cd figures
        min=`echo $range | awk '{printf $1}'` 
        max=`echo $range | awk '{printf $2}'`
        step=`echo $range | awk '{printf $3}'`
        minxtics=`echo $range | awk '{printf $4}'`
        maxxtics=`echo $range | awk '{printf $5}'`
        stepxtics=`echo $range | awk '{printf $6}'`
        minytics=`echo $range | awk '{printf $7}'`
        maxytics=`echo $range | awk '{printf $8}'`
        stepytics=`echo $range | awk '{printf $9}'`
        cat << EOF > $kw.was
f(x) := $kw(x)
PRINT_FUNCTION f MIN $min MAX $max STEP $step
EOF
        wasora $kw.was > $kw.dat
        cat << EOF > $kw.ppl
set preamble "\usepackage{amsmath} \usepackage{amssymb}"
set width 10*unit(cm)
set size ratio 0.35
set axis x arrow nomirrored
set axis y arrow nomirrored
# set nomytics
# set nomxtics
set nokey
EOF
        if [ ! -z "$minxtics" ]; then
          echo "set xtics $minxtics,$stepxtics,$maxxtics" >> $kw.ppl
        fi
        if [ ! -z "$maxytics" ]; then
          echo "set ytics $minytics,$stepytics,$maxytics" >> $kw.ppl
        fi

        cat << EOF >> $kw.ppl
set xrange [$min:$max]
set xlabel "\$x\$"
set ylabel "$escapedkw\$(x)\$"
set terminal pdf
set output "$kw.pdf"
plot "$kw.dat" w l lw 3 color blue
# svg does not work yet!
# set terminal svg
# set output "$kw.svg"
# replot
set terminal png dpi 120
set output "$kw.png"
replot
EOF
        pyxplot $kw.ppl
#         rm -f $kw.was
#         rm -f $kw.ppl
#         rm -f $kw.dat
        cd ..
       fi

      cat << EOF >> ${src[$i]}.$ext
!bslidecell 01
FIGURE: [figures/$kw]
!eslidecell
EOF
      fi
      cat << EOF >> ${src[$i]}.$ext
# end-grid-area
EOF
    fi

# detailed description
    echo >> ${src[$i]}.$ext
    cat ../src/${src[$i]}.c | grep //${tag[$i]}+$kw+detail  | cut -d\  -f2- >> ${src[$i]}.$ext
    echo  >> ${src[$i]}.$ext 

# examples
    exs=`cat ../src/${src[$i]}.c | grep //${tag[$i]}+$kw+example  | cut -d\  -f2-` 
    n=0
    for ex in $exs; do
      n=`echo $n + 1 | bc`
# el chiste es que si hacemos cat el doconce rompe los comentarios
# del input de wasora porque piensa que son comentarios para el
# #if FORMAT in ("latex", "pdflatex")"
# \lstinputlisting[style=wasora,title=$input.was]{examples/$ex}
# #else
# #endif

      cat << EOF >> ${src[$i]}.$ext
!bnotice Example #$n, $ex
!bc wasora
EOF
      cat examples/$ex >> ${src[$i]}.$ext
      cat << EOF >> ${src[$i]}.$ext
!ec

EOF

# terminal
      if [ -e examples/$ex.sh ]; then
        cat << EOF >> ${src[$i]}.$ext
!bc console
EOF
        k=1
        cd examples
        rm -f $ex.term
        n=`wc -l < $ex.sh`
        while [ $k -le $n ]; do
         cat $ex.sh | head -n $k | tail -n1 > tmp
         echo -n "\$ " >> ../${src[$i]}.$ext
         cat tmp >> ../${src[$i]}.$ext
         chmod +x tmp
         script -aq -c ./tmp $ex.term 2>&1 | grep error: > errors
         if [ ! -z "`cat errors`" ]; then
           echo "error: something happened on the way to heaven"
           cat ./tmp
           cat errors
           exit 1
         fi
         k=`echo $k + 1 | bc`
        done
        cat $ex.term | grep -v Script | sed s/^\\.\$/\$/ >> ../${src[$i]}.$ext
        cd ..
        cat << EOF >> ${src[$i]}.$ext
$
!ec

EOF
      fi

# figure
      if [ -e examples/$ex.fig ]; then
        echo "FIGURE: [examples/`cat examples/$ex.fig`]" >> ${src[$i]}.$ext
      fi


      cat << EOF >> ${src[$i]}.$ext

!enotice

EOF

    done

  done

  echo >> ${src[$i]}.$ext 

done

