#!/bin/bash
if [ -e ./runtest.sh ]; then
 . ./runtest.sh
elif [ -e examples/runtest.sh ]; then
 . examples/runtest.sh
else
 echo wrong PWD
 exit 77
fi


if [ `${wasorabin} -v | grep SUNDIAL | wc -l` = 0 ]; then
 echo "wasora was not compiled with IDA, skipping test"
 exit 77
fi

${wasorabin} ${testdir}lorenz.was > lorenz.dat
outcome=$?

if [ "x`which gnuplot`" != "x" ]; then
 if [ "x`uname | cut -c-6`" = "xCYGWIN" ]; then
  if [ "x`ps -e | grep X | wc -l`" = "x0" ]; then
   XWin.exe -multiwindow -clipboard -silent-dup-error > /dev/null &
   sleep 2
  fi
  export DISPLAY=:0.0
 fi
 gnuplot -p -e "splot 'lorenz.dat' u 2:3:4 w l lt 2 ti ''"
fi

exit $outcome
