doconce clean
#doconce format html examples
# doconce format html examples --html_style=solarized --html_output=examples_solarized --pygments_html_style=perldoc --html_admon=apricot

videos="012-mechanics/newton.webm \
        018-waterwheel/waterwheel.webm \
        018-waterwheel/realwheel.webm \
        017-double-pendulum/trajectories.webm \
        078-boiling-channel/uniform.webm\
        078-boiling-channel/sine.webm\
        078-boiling-channel/arbitrary.webm"

for video in ${videos}; do
 cp $video .
done

doconce format sphinx realbook --no_mako || exit
doconce split_rst realbook || exit
doconce sphinx_dir version=0.2 dirname=sphinx theme=basicstrap realbook || exit
./automake_sphinx.py || exit



for video in ${videos}; do
 cp `basename $video` sphinx/_build/html/
done
cp sphinxsections.php sphinx/_build/html/

cd sphinx
sed -i s/pygments_style\ =\ \'sphinx\'/pygments_style\ =\ \'trac\'/ conf.py
sed -i s/\'stickysidebar\':\ \'false\'/\'stickysidebar\':\ \'true\'/ conf.py
sed -i s/#html_search_language/html_search_language/ conf.py
make html
cd ..

# doconce format pdflatex examples
# ptex2tex -DMINTED examples
# pdflatex realbook
