/*------------ -------------- -------- --- ----- ---   --       -            -
 *  dae evaluation routines
 *
 *  Copyright (C) 2009--2013 jeremy theler
 *
 *  This file is part of wasora.
 *
 *  wasora is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  wasora is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with wasora.  If not, see <http://www.gnu.org/licenses/>.
 *------------------- ------------  ----    --------  --     -       -         -
 */

#include "wasora.h"


#ifdef HAVE_IDA
 #include <sundials/sundials_math.h>
 #include <sundials/sundials_types.h>
#endif


#ifdef HAVE_IDA
int wasora_ida_dae(realtype t, N_Vector yy, N_Vector yp, N_Vector rr, void *params) {

  int i;
 
//   phase_object_t *phase_object;
//   LL_FOREACH(wasora_dae.phase_objects, phase_object) {
//     printf("%s %d\n", phase_object->name, phase_object->differential);
//   }          
//   exit(0);

  
  // esta funcion se llama un monton de veces en pasos de tiempo
  // intermedios, entoces le decimos cuanto vale el tiempo nuevo por
  //  si hay residuos que dependen explicitamente del tiempo
  wasora_var(wasora_special_var(time)) = t;

  for (i = 0; i < wasora_dae.dimension; i++) {
    *(wasora_dae.phase_value[i]) = NV_DATA_S(yy)[i];
    *(wasora_dae.phase_derivative[i]) = NV_DATA_S(yp)[i];
  }

  for (i = 0; i < wasora_dae.dimension; i++) {
    if (wasora_dae.residual[i].row.n_tokens != 0) {
      wasora_var(wasora_special_var(i)) = wasora_evaluate_expression(&wasora_dae.residual[i].row);
    }
    if (wasora_dae.residual[i].col.n_tokens != 0) {
      wasora_var(wasora_special_var(j)) = wasora_evaluate_expression(&wasora_dae.residual[i].col);
    }
    NV_DATA_S(rr)[i] = wasora_evaluate_expression(*wasora_dae.residual[i].expr);
  }
  
#else
 int wasora_ida_dae(void) {
#endif

   return WASORA_RUNTIME_OK;

}

// instruccion dummy
int wasora_instruction_dae(void *arg) {
  
  return WASORA_RUNTIME_OK;
  
}
